c
c ***************************************************************************
c
c                   P A R A M E T E R    S T A T E M E N T S
c
c ---------------------------------------------------------------------------
c     THE VAX AND PC IMPLEMENTATION OF THIS FILE ARE IDENTICAL
c     EXCEPT FOR THE PARAMETER STATEMENT SETTINGS OF NXDIM AND NYDIM.
c
c     Recommended settings are:
c
c      IBM PC (or compatible) -
c          with 512K RAM:          nxdim = 30, nydim = 400
c          with 640K RAM:          nxdim = 40, nydim = 500
c      VAX 11/785 -                nxdim = 50, nydim = 600
c
c     Settings for the VAX can be even larger if needed.
c
c
c     The version number is also assigned here in MINTEQA2.INC via
c     a parameter statement.
c
c ***************************************************************************
      character version*5
      integer nxdim, nydim
      real*8 eps
c
c -- Set bounds on number of species (nydim) and number of components
c    (nxdim) and set convergence criteria (eps).
      parameter ( nxdim = 35, nydim = 450, eps = 1.0d-4 )
      parameter ( idclf = 145, idcll= 149 )
c
c  -- Assign version number (version).
      parameter (version = 'v3.10')
c
      character*1 xstop, fxdph, fxdpe, reguess  
c
      character   flag*5, units*5, errcode*7, name*12, fil123*12
c
      logical     vds5xist
c
      integer*2   jmax, jpta, imax, ipta, jmaxcl, jptacl
c
      integer*4   icoralk, isweep, iprob, nprob, mprob, n123,  
     *            idtime, iddate, scrnout, ntyp123, itmax, iter,
     *            iads, numads, nnn, iprint, idebug, kount, icharg,
     *            niter, kkdav, kkthr, isopt, iprdct, iparm,  
     *            ierrtotl, ierr, lun01, lun02, lun03, lun04, 
     *            lun07, lun10, lun11, lun14, lunout, ierrin, m2, 
     *            nn, idydum, id123, nrxcl, idrxcl,
     *            idx, idy, idwrite, nidxcl, idxcl
c
      real*4      a, alkfct, dha, dhb, gfw, maxgk, mingk, spcz, stoica
      real*8      b, c, gc, x, gx, z, y, gk, t, aa, bb, gamma,
     *            cap1, cap2, dens, ee, fcc, fions, xmu, dh,  
     *            noncrb, psi0, psib, psid, r, rj, solcon, ssa,
     *            temp, tempk, tis, vh, vhc, sig0, sigb, 
     *            sigd, uvalue, systempe, systemph, 
     *            sigma, gkcl, cppm 
c                 
c
c     ________________________________________________________________
c                      -------  COMMON BLOCKS  -------
c
      common /charsc/  xstop, fxdph, fxdpe, flag, units, errcode,
     *                 fil123
c
      common /char1d/  reguess(nxdim), name(nydim)
c
      common /logic/   vds5xist
c
      common /int2d1/  imax(nxdim), jmax(nydim), jmaxcl(14)
c
      common /int2d2/  ipta(nxdim,100), jpta(nydim,12), jptacl(14,4)
c
      common /int4sc/  icoralk, isweep, iprob, nprob, mprob, n123,  
     *                 idtime, iddate, scrnout, ntyp123, itmax, iter,
     *                 iads, numads, nnn, iprint, idebug, kount,
     *                 icharg, niter, kkdav, kkthr, isopt, iprdct, 
     *                 iparm, ierrtotl, ierr, lun01, lun02, lun03, 
     *                 lun04, lun07, lun10, lun11, lun14, lunout,
     *                 ierrin, nrxcl, idwrite, nidxcl 
c     
      common /int4d1/  m2(5), nn(6), id123(6), idrxcl(14), 
     *                 idx(nxdim), idydum(100), idy(nydim), idxcl(14)
c
      common /real4d1/ alkfct(nydim),dha(nydim),dhb(nydim),
     *                 mingk(nydim),maxgk(nydim),gfw(nydim),spcz(nydim)
c
      common /real4d2/ a(nydim,nxdim), stoica(14,14)
c
      common /real8sc/ aa, bb, dens, ee, fcc, fions, xmu,  
     *                 noncrb, r, rj, temp, tempk, tis, vh, vhc,  
     *                 systempe, systemph, sigma, cppm
c
      common /real8d1/ cap1(5), cap2(5), psi0(5), psib(5), psid(5), 
     *                 solcon(5), ssa(5), sig0(5), sigb(5), sigd(5), 
     *                 uvalue(24), gkcl(14), x(nxdim), gx(nxdim), 
     *                 t(nxdim), y(nxdim), gk(nydim), c(nydim), 
     *                 gc(nydim), gamma(nydim),dh(nydim)
c
      common /real8d2/ b(nydim,nxdim),z(nxdim,nxdim)
