      subroutine delay (isec)
c
c  -- The purpose of this subroutine is to provide a means of
c     delaying execution of the calling program for "isec"
c     seconds.  The method used is to make an initial call
c     to GETTIM, convert the hours, minutes, seconds returned
c     to total seconds, then to make repeated calls to that same
c     routine and, after a similar conversion, to difference the
c     two total seconds.  Stop calling GETTIM and return to the
c     calling program when the absolute value of the difference
c     exceeds the requested delay time, isec.
c
C  -- The VAX and PC versions of this routine are different. This
C     is the PC version.
C
      integer*2  hr, mn, sc, hd, isec, tsec1, tsec2, tdiff
c
      call gettim(hr,mn,sc,hd)
      tsec1 = hr*3600 + mn*60 + sc
c
   10 call gettim(hr,mn,sc,hd)
      tsec2 = hr*3600 + mn*60 + sc
      tdiff = abs(tsec1-tsec2)
      isec = abs(isec)
      if (tdiff.lt.isec) go to 10
c
      return
      end
