      subroutine maind
c
c *******************************************************************
c
c THIS IS THE MAIN DRIVER FOR MINTEQ. THE PROGRAM IS SET UP TO
c EXECUTE MULTIPLE DATA SETS STORED IN THE SAME FILE. THIS FORMAT
c ALLOWS ALL DATA SETS IN THE FILE TO BE EXECUTED EVEN IF AN
c ERROR OCCURS IN ONE OF THE FILES.
c
c *******************************************************************
c
      include 'MINTEQA2.INC'
c
c -- THE INCLUDE FILE HAS A PARAMETER STATEMENT THAT SETS BOTH
c    NXDIM AND NYDIM.  (THEIR VALUES DEPEND UPON THE MEMORY
c    CAPACITY OF THE COMPUTER.)  THE INCLUDE STATEMENT ABOVE
c    MUST COME BEFORE THE DIMENSION STATEMENT FOR GK1 SINCE
c    NYDIM IS USED FOR AN ADJUSTABLE ARRAY DIMENSION. 10-14-87 JDA
c
      dimension gk2(nydim)
c
      real*8 gk2
      integer idxx
      character sweep*10, problm1*1, lastime*1, action*12, state*5
c
      problm1 = 'y'
      xstop = 'n'
      mprob = 0
      ierr =  0
c
  100 continue
        if (ierr.gt.0.and.ierr.le.7) go to 999
        if (ierr.gt.7) problm1 = 'y'
        lastime ='n'
c
c
c  -- Call INPUT to initially read the input file for this problem
c     and to read in the appropriate data from database files.  At
c     the conclusion of the current problem, call INPUT again to
c     read the next problem in a multi-problem file, or, failing to
c     find a next problem, transfer control back to program MINTEQA2
c     with XSTOP = 'Y' to stop execution.
      if (problm1.eq.'y') then
        iprob = 1
        mprob = mprob + 1
        k1 = 0
        call init
        call input (idxx, sweep)
        if (ierr.ne.0) go to 999
        if (xstop.eq.'y') go to 999
c
c  -- If this is other than the initial problem in a series of
c     problems involving multiple runs at various fixed pH's
c     (but NOT a multi-problem file, rather a single-problem file
c     with a titration operation specified), then call NXTPRB to
c     generate the problem for the next run, or if the previous run
c     was the last run, transfer control back to program MINTEQA2
c     with XSTOP = 'y' to stop execution.
      else
        call nxtprb (idxx, sweep)
        if (xstop.eq.'y') then
           problm1 = 'y'
           xstop = 'n'
           go to 100
        end if
      end if
c
      if (iprob.eq.1) then
        call prep
        call guess
      end if
      if (ierr.ne.0) go to 100
      if (isopt.ne.0.and.iprob.eq.1) call actvty
  140 continue
c
c STORE TEMPERATURE CORRECTED LOGK FOR USE EACH ITERATION
c IN SOLID SELECTION LOOP
c
      if (isopt.ne.0) go to 160
      i3 = nn(1)+nn(2)
      do 150 i = 1, i3
         if (iter.eq.0.and.iprob.eq.1) then
            gk2(i) = gk(i)
         else
            gk(i) = gk2(i)
         endif
  150 continue
  160 continue
c
      call solid
      if (ierr.ne.0) go to 100
c
      if (isopt.eq.0) then
         call kcorr2
      end if
c
      call solve
      if (ierr.ne.0) go to 100
c
      call solidx (action,k1)
c
c  -- SOLIDX returns a value of zero for k if no solid precipitated
c     or dissolved.  Thus, if the returned value of k is other than
c     zero, the solution must be re-equilibrated.
      k1 = k1+1
      if (action.ne.'finished    ') go to 140
      lastime = 'y'
      call outcmp
      call outspc (lastime)
      call outpc (lastime)
      state = 'both '
      call iap (state)
      if (isweep.gt.0) problm1 = 'n'
      go to 100
  999 return
c
      end
